-- aim_meleecontest (Ghost mod) script by Uaiek
function array(m,s)
	local array = {}
	for i = 1,m do
		array[i] = s
	end
	return array
end

--[[ Settings ]]--

tspd = 5 -- Terrorist start speed
ctwpn = 39 -- Counter-Terrorists start weapon
ExtraDamage = 5 -- Extra damage given for counter-terrorists (increase by each killing)
ExtraSpeed = 10 -- Extra speed given for terrorists (increase by each killing)
ExtraWeapon = 10 -- Terrorists extra weapon (given by each killing)
-- Blink settings
cooldown = 5000 -- blink cooldown duration in milisecond(1/1000 seconds) unit
-- Misc.
knockback = false
ablinkstrike = false -- toggled by throwing a smoke grenade

--[[ End of Settings ]]--

kc = array(32,1)
Xdmg = array(32,0)
Eball_img = array(32,0)
Glow_img = array(32,0)
math.randomseed(os.time())

addhook("startround","_startround")
function _startround()
	for i = 1,32 do
		kc[i] = 1
		Xdmg[i] = 0
	end
end

addhook("kill","_kill")
function _kill(k,v)
	local speed = kc[k]*ExtraSpeed
	if player(k,"team")==1 then
		parse("speedmod "..k.." "..speed)
		msg2(k,"100255200You killed "..player(v,"name")..". Your speed increases to "..speed)
		kc[k] = kc[k]+1
	else
		if kc[k] < 6 then
			Xdmg[k] = kc[k]*ExtraDamage
			msg2(k,"000255200You killed "..player(v,"name")..". DAMAGE + "..Xdmg[k])
			kc[k] = kc[k]+1
			EnergyBall(k)
		end
	end
end
		

addhook("spawn","_spawn")
function _spawn(p)
	if player(p,"team")==1 then
		parse("equip "..p.." 85")
		parse("equip "..p.." 69")
		parse("setweapon "..p.." 69")
		parse("setarmor "..p.." 206")
		parse("equip "..p.." 52")
		parse("speedmod "..p.." 5")
	else
		parse("equip "..p.." "..ctwpn)
		parse("setweapon "..p.." "..ctwpn)
	end
end

addhook("hit","_hit")
function _hit(p,s,w,hpd)
	local dmg = hpd+Xdmg[s]
	local hpleft = player(p,"health")-dmg
	if player(p,"team") ~= player(s,"team") then
		if Xdmg[s] >= ExtraDamage then
			parse("flashplayer "..p.." 10")
			parse("shake "..p.." 10")
			if player(p,"health") > dmg then
				parse("sethealth "..p.." "..hpleft)
				return 1
			else
				parse('customkill '..s..' "Powered '..itemtype(w,"name")..' (+'..Xdmg[s]..' Damage)" '..p)
				return 1
			end
		end	
	end	
	return 0
end
	
addhook("drop","_drop")
function _drop()
	return 1
end

addhook("die","_die")
function _die(p,k,w,x,y)
	if player(p,"team") == 1 then
		parse('effect "flare" '..x..' '..y..' 50 0 255 255 255')
		return 1
	end
end

function EnergyBall(p)
	local b = Eball_img[p]
	if kc[p] == 2 then
		Eball_img[p] = image("gfx/aim_meleecontest/EnergyBall I.bmp",0,0,p+132)
		Glow_img[p] = image("gfx/sprites/flare2.bmp",0,0,p+100)
		imagecolor(Glow_img[p],0,0,255)
		imageblend(Glow_img[p],1)
		imagealpha(Glow_img[p],0)
		tween_alpha(Glow_img[p],600,1)
		imagecolor(Eball_img[p],0,0,255)
		imageblend(Eball_img[p],1)
		imagealpha(Eball_img[p],0)
		tween_alpha(Eball_img[p],1000,1)
		tween_rotateconstantly(Eball_img[p],1)
	end
	if kc[p] == 3 then
		freeimage(b)
		Eball_img[p] = image("gfx/aim_meleecontest/EnergyBall II.bmp",0,0,p+132)
		imagecolor(b,0,0,255)
		imageblend(b,1)
		imagealpha(b,0)
		tween_alpha(b,1000,1)
		tween_rotateconstantly(b,1)
	end
	if kc[p] == 4 then
		freeimage(b)
		Eball_img[p] = image("gfx/aim_meleecontest/EnergyBall III.bmp",0,0,p+132)
		imagecolor(b,0,0,255)
		imageblend(b,1)
		imagealpha(b,0)
		tween_alpha(b,1000,1)
		tween_rotateconstantly(b,1)
	end
	if kc[p] == 5 then
		freeimage(b)
		Eball_img[p] = image("gfx/aim_meleecontest/EnergyBall IV.bmp",0,0,p+132)
		imagecolor(b,0,0,255)
		imageblend(b,1)
		imagealpha(b,0)
		tween_alpha(b,1000,1)
		tween_rotateconstantly(b,1)
	end
	if kc[p] == 6 then
		freeimage(b)
		Eball_img[p] = image("gfx/aim_meleecontest/EnergyBall V.bmp",0,0,p+132)
		imagecolor(b,0,0,255)
		imageblend(b,1)
		imagealpha(b,0)
		tween_alpha(b,1000,1)
		tween_rotateconstantly(b,1)
	end
end

addhook("minute","_min")
function _min()
	local ran = math.random(1,4)
	if ran == 1 then
		msg("000200255Tip: Press F4 to enable or disable blink")
	elseif ran == 2 then
		msg("000200255Tip: Blink is only toggled by using knife.")
	elseif ran == 3 then
		msg("000200255Tip: The forbidden area means that area is out of map bound")
		msg("000200255or forbidden by the map maker.")
	elseif ran == 4 then
		local cd = math.floor(cooldown/1000)
		msg("000200255Tip: Each blink has cooldown for "..cd.." seconds.")
	end
	msg("Press F2 (serveraction #1) to see game information.")
	msg("Press F3 (serveraction #2) to see your status.")
end

addhook("serveraction","_sa")
function _sa(p,a)
	if a == 1 then
		msg2(p,"255255255  .: Game Information :.")
		msg2(p,"200200200     > CT's weapon is "..itemtype(ctwpn,"name"))
		msg2(p,"200200200     > [CT] Extra damage for each kill is "..ExtraDamage)
		msg2(p,"200200200     > [TR] Extra speed for each kill is "..ExtraSpeed)
		msg2(p,"200200200     > [TR] Extra weapon for each kill is "..itemtype(ExtraWeapon,"name"))
	end
	if a == 2 then
		msg2(p,"255255255 .: Your Status :.")
		msg2(p,"200200200     > Your extra damage: "..Xdmg[p])		
		msg2(p,"255000000Note: Your extra stuff will be reset each roundstart")		
	end
	if a == 3 then
		if player(p,"team") == 1 then
			if blinkenable[p] == true then
				blinkenable[p] = false
				parse('hudtxt2 '..p..' 1 "120120120Disabled" 425 450 0')
			else
				blinkenable[p] = true
				parse('hudtxt2 '..p..' 1 "000255000Enabled" 425 450 0')
			end
		else
			msg2(p,"255000000Only terrorists can enable blink@C")
		end
	end
end

addhook("team","cteam")
function cteam(id,team)
	if team == 2 then
		blinkenable[id] = false
		parse('hudtxt2 '..id..' 1 "120120120Disabled" 425 450 0')
	end
end

-- Blink and knockback script by Uaiek
-- March 15th 2012
pX = array(32,nil)
pY = array(32,nil)
cX = array(32,nil)
cY = array(32,nil)
blinkable = array(32,true)
blinkenable = array(32,false)
math.randomseed(os.time())
fbd = 4 --[[ fbd is a value of entity type that is forbidden to blink in its area.
fbd = 1 means TRandCT spawnpoint,2 means VIPspawnpoint,4 means HostageRescuepoint,5 means BombSpot,6 means EscapePoint ]]--

--[[ addhook("hit","vangeful") -- Swap player's position with your hit enemy position, triggered by deagle(id 3).
function vangeful(id,s,wpn)
	if id ~= 1 then
		if wpn == 3 then
			pX[s] = player(s,'x')
			pY[s] = player(s,'y')
			parse('setpos '..s..' '..player(id,'x')..' '..player(id,'y'))
			parse('setpos '..id..' '..pX[s]..' '..pY[s])	
		end
	else
		return 1
	end
end ]]--

addhook("projectile","blinkstrike")
function blinkstrike(id,wpn,x,y)
	if ablinkstrike then
		if wpn == 53 then
			if notfbdob(x,y) then
				parse('setpos '..id..' '..x..' '..y)
			end
		end
	end
end

function blink_allow(p)
	local x = tonumber(p)
	blinkable[x] = true
	parse('hudtxt2 '..x..' 2 "" 425 450 0')
end

function notfbdob(x,y)
	if not inentityzone(math.floor(x/32),math.floor(y/32),fbd) and x > 0 and y > 0 and math.floor(x/32) <= map("xsize") and math.floor(y/32) <= map("ysize") then
		return true
	else
		return false
	end
end
	
	
addhook("attack","blink")
addhook("clientdata","blink_data")
function blink(id)
	if blinkenable[id] == true and blinkable[id] == true and player(id,"weapontype") == 50 then
		reqcld(id,2)
		function blink_data(id,mode,d1,d2)
			if mode == 2 then
				cX[id] = d1
				cY[id] = d2
				if not tile(math.floor(cX[id]/32),math.floor(cY[id]/32),"wall") and not tile(math.floor(cX[id]/32),math.floor(cY[id]/32),"obstacle") then
					if notfbdob(cX[id],cY[id]) then
						blinkable[id] = false
						timer(cooldown,"blink_allow",id)
						parse('setpos '..id..' '..cX[id]..' '..cY[id])
						parse('effect "flare" '..cX[id]..' '..cY[id]..' 50 20 255 255 255')
						parse('hudtxt2 '..id..' 2 "255000000(Cooldown)" 417 440 0')
						-- msg2(id,"255000000X:"..cX[id]..", Y:"..cY[id].."@C")
					else
						msg2(id,"255000000This area is forbidden to blink@C")
					end
				else
					msg2(id,"255000000You can't blink into a wall or an obstacle!@C")
				end
			end
		end
	end
end
		
addhook("hit","stun")
function stun(id,s,wpn,hpdmg)
	if knockback then
		local rot = math.abs(player(s,"rot")-90)
		local x = player(id,"x") + hpdmg*math.cos(math.rad(rot))
		local y = player(id,"y") + hpdmg*math.sin(math.rad(rot))
		if not tile(math.floor(x/32),math.floor(y/32),"wall") and not tile(math.floor(x/32),math.floor(y/32),"obstacle") then 
			parse('setpos '..id..' '..x..' '..y)
		end
	end
end

addhook("join","_join")
function _join(id)
	parse('hudtxt2 '..id..' 1 "120120120Disabled" 425 450 0')
end

addhook("leave","_leave")
function _leave(id)
	blinkenable[id] = false
	blinkable[id] = true
	freetimer("blink_allow",id)
end

print("000255000LUA SCRIPT INITIALIZED SUCCESSFULLY.")
print("000000255Counter-Terrorists weapon = "..itemtype(ctwpn,"name").."")